(function() {

    var app = angular.module('FuelIoc');
    var McsService = function($ionicPlatform, $http, $timeout, $ionicModal) {



        var registerInMcs = function() {
            mcs.MobileBackendManager.platform = new mcs.CordovaPlatform();
            mcs.MobileBackendManager.setConfig(mcs_config);
            mcsBackend = mcs.MobileBackendManager.getMobileBackend("FuelAtIOC");

            if (mcsBackend != null) {
                mcsBackend.setAuthenticationType("basicAuth");

                mcsBackend.Authorization.authenticateAnonymous(
                    function(response, data) {
                        var options = {
                            android: {
                                senderID: "1047884479163"
                            },
                            ios: {
                                alert: "true",
                                badge: "true",
                                sound: "true"
                            },
                            windows: {}
                        };

                        // initialize
                        $cordovaPushV5.initialize(options).then(function() {
                            // start listening for new notifications
                            $cordovaPushV5.onNotification()
                            {
                                alert('Notification occured');
                            }
                            // start listening for errors
                            $cordovaPushV5.onError();
                            alert('Before Registration');
                            // register to get registrationId
                            $cordovaPushV5.register().then(function(registrationId) {
                                alert('Token is ' + registrationId);
                                //mcs.MobileBackendManager.Notifications = new mcs._Notifications(mcsBackend);
                                mcsBackend.Notifications.registerForNotifications(registrationId, "com.iocl.maps", "1.0.0", registerSuccess, registerError);

                                function registerSuccess(response) {
                                    alert('Success device reg in mcs ' + response.statusCode);// returns statusCode for this function.
                                    //sendNotifications(registrationId);
                                }
                                function registerError(response) {
                                    alert('Error ' + response);// returns statusCode for this function.
                                }
                            })
                        });
                    },
                    function(statusCode, data) {
                        alert('Status code is ' + statusCode + ' Data is ' + JSON.stringify(data));
                    });
            }
        }


        return {

            registerInMcs: registerInMcs,

        }

    };
    app.factory("McsService", McsService);

} ());