(function() {

    var app = angular.module('FuelIoc');
    
    var user = function($http,  $ionicLoading) {
        
        var userProfile = { 
                            userId: "", 
                            name: "", 
                            mobile: "", 
                            email: "", 
                            address:"", 
                            city: "",
                            pinCode: "",
                            gender: ""
                        };
        
        var ratedRos = [];
        var sendOtp = function(mobile) {
            var data = {status:true, rotp:1234};
            return data;
        }
        
        var isUserExist = function(email, mobile) {
            return $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSGetUser/?email="+email+"&mobile="+mobile)
                    .then(function(response) {
                    if(response.data==null) {
                        return false;
                    } else {
                        return true;
                    }
                });
        }
        
        var loginUser = function(username, password) {
            
            var mobile = username;
                if (isNaN(mobile)) {
                    mobile = -1;
                }
                return $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/FuelIOC/RSUserLogin/?emailId=" + username + "&mobile=" + mobile + "&password=" + password)
                    .then(function(response) {
                    return response.data;
                });
                
              /*  
                cordovaHTTP.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/FuelIOC/RSUserLogin/?emailId=" + username + "&mobile=" + mobile + "&password=" + password)
                    .then(function(response) {
                    return response.data;
                });
                */
        };
        
        var setUser = function(data) {
            if(data!=null) {
                userProfile = data.FaiUserProfile[0];
               
                for (var key in userProfile) {
                      
                            if(JSON.stringify(userProfile[key]).indexOf("@nil")>-1)
                            {
                                userProfile[key] = "";
                            }
                }
            } else {
                userProfile = { userId: "", 
                                name: "", 
                                mobile: "", 
                                email: "", 
                                address:"", 
                                city: "",
                                pinCode: "",
                                gender: ""
                                };
            }
            return true;
        }
        
        
        var updateProfile = function(user,callBack){
            var content = {
                FaiUserProfile :
                [{
                    userId: user.userId, 
                    name: user.name, 
                    mobile: user.mobile, 
                    email: user.email, 
                    address: user.address, 
                    city: user.city,
                    pinCode: user.pinCode,
                    gender: user.gender,
                    xtraReward:user.xtraReward
                    
                }]
            };
            
            return $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSUserProfile/", content)
                                         .then(function(response) {
                                             callBack(response.status);
                                         })
            
            
        }
        
        var createUser = function(user,callBack) {
            var content = {
                FaiUserProfile :
                [
                    {
                    name : user.name,
                    email : user.email,
                    mobile : user.mobile,
                    password : user.password,
                    address: user.address, 
                    city: user.city,
                    pinCode: user.pinCode,
                    gender: user.gender,
                    xtraReward:user.xtraReward
                    }
                 ]
            };
                            
                    
             $http(
              {
              url : "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSUserProfile/",
              method: "POST",
              headers: {
                'Accept': '*/*; charset=UTF-8',
                'Content-Type': 'application/json'   
              },
              data: content
            })
             .then(function(responseA) {
                   if(responseA.status==204 || responseA.status==200) {
                       $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSGetUser?mobile="+user.mobile)
                            .then(function(response){
                                if(response.data!=null) {
                                    setUser(response.data);
                                    callBack(responseA.status,response.data);
                            }               
                            }, function() {
                                // do nothings
                            });
                            
                   }  else {
                       callBack(500);
                   }
                 })     
        }
        
        var populateRtdRos = function(mobileNo)
        {
            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSRatedRO?mobile='+mobileNo,
                {
                    params: {}
                }).success(function(data, status) {
                    if(data && data.dbRatedRoListOutput)
                    {
                        ratedRos = data.dbRatedRoListOutput;
                    }
                    
                });
        }
        
        var getRtdRos = function()
        {
            return ratedRos;
        }
        
        var getUser = function() {
                return userProfile;
        }
        
        var previousView="";
        var isFirst = true;
        var mapView = "";
        var FromMapViewPay=false;
        var setpreviousView = function(value){
            previousView = value;
        }
        var getpreviousView = function()
        {
            return previousView;
        }
        var getIsFirst = function()
        {
            return isFirst;
        }
        var setIsFirst = function()
        {
            isFirst = false;
        }
        
        var getMapView = function()
        {
            return mapView;
        }
        var setMapView = function(val)
        {
            mapView = val;
        }
        var setFromMapViewPay = function(val)
        {
            FromMapViewPay = val;
        }
        var getFromMapViewPay = function()
        {
            return FromMapViewPay;
        }
       
        return {
            loginUser: loginUser,
            setUser: setUser,
            getUser: getUser,
            isUserExist: isUserExist,
            sendOtp: sendOtp,
            createUser: createUser,
            updateProfile: updateProfile,
            profile:userProfile,
            setpreviousView:setpreviousView,
            getpreviousView:getpreviousView,
            getIsFirst:getIsFirst,
            setIsFirst:setIsFirst,
            getMapView:getMapView,
            setMapView:setMapView,
            setFromMapViewPay:setFromMapViewPay,
            getFromMapViewPay:getFromMapViewPay,
            getRtdRos:getRtdRos,
            populateRtdRos:populateRtdRos
        }
    };
    app.factory("userService", user);

} ());
