(function () {

    var app = angular.module('FuelIoc');

    var AppVersionMgmt = function ($http, $ionicLoading, $ionicPopup, $state) {
        var checkVersionUpdate = function (callBk) {
            
            /*
            if(typeof cordova !== 'undefined' && cordova !== null)
            {
                cordova.getAppVersion(function(version) {
                    getPlayStoreOrAppStoreVersion(version, callBk);
                });
            }
            else
            {
                callBk();
            }
            */
            getPlayStoreOrAppStoreVersion("6.0.14", callBk);
        }
        
        function getPlayStoreOrAppStoreVersion(Version,callBk)
        {
          var isIOS = ionic.Platform.isIOS();
          var isAndroid = ionic.Platform.isAndroid();
          var plStoreOrApStoreVersion = "";
          var url = "";
          if(isIOS)
          {
              url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSAppVersion?app_name=FUELAIOC&os=IOS";
          }
          else if(isAndroid)
          {
              url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSAppVersion?app_name=FUELAIOC&os=ANDROID";
          }
        
          $http.get(url)
              .success(function(data) {
                  if (data) 
                  {         
                      if (data.MobileAppVersions && data.MobileAppVersions.length > 0) {
                          plStoreOrApStoreVersion = data.MobileAppVersions[0].appVersion;
                          if (plStoreOrApStoreVersion != Version) {
                              $state.go('versionMgmt');
                          }
                          else {
                              callBk();
                          }
                      }
                      else {
                              callBk();
                      }    
                            
                  }
                  else
                  {
                      callBk();
                  }
              }).error(function() {
                 callBk();
              });
              
          
        }
        return {
            checkVersionUpdate: checkVersionUpdate,
            
        }
    };
    app.factory("AppVersionMgmt", AppVersionMgmt);

} ());